package cambiavalute.ui.controller;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.OptionalDouble;

import cambiavalute.model.CambiaValute;
import cambiavalute.model.TassoDiCambioUfficiale;

public class MyController extends Controller {

	public MyController(UserInteractor userInteractor,
			Map<String,TassoDiCambioUfficiale> cambiUfficiali, 
			List<CambiaValute> listaCambiaValute) {
		super(userInteractor, cambiUfficiali, listaCambiaValute);
	}
	
	public Map<String,OptionalDouble> changeTo(String siglaValutaEstera, double importo){
		Map<String,OptionalDouble> cambiDisponibili = new HashMap<>();
		for (CambiaValute cv : getListaCambiaValute()){
			OptionalDouble result = cv.vendita(siglaValutaEstera, importo);
			cambiDisponibili.put(cv.getNomeAgenzia(), result);
		}
		return cambiDisponibili;
	}
	
	public Map<String,OptionalDouble> changeFrom(String siglaValutaEstera, double importo){
		Map<String,OptionalDouble> cambiDisponibili = new HashMap<>();
		for (CambiaValute cv : getListaCambiaValute()){
			OptionalDouble result = cv.acquisto(siglaValutaEstera, importo);
			cambiDisponibili.put(cv.getNomeAgenzia(), result);
		}
		return cambiDisponibili;
	}
	
}
